
    
    $crop_job = 0;  	    	    # Do image cropping job ?
    $preview_job = 0;	    	    # Do preview GIF animation job ?
    $jpeg_job = 0;  	    	    # Make JPEG frames
    $avi_job = 1;   	    	    # Encode JPEG frames and MP3 sound track as AVI movie
    $ppm_job = 0;   	    	    # Make PPM files
    
    $grab = '../DV_capture/Frames'; # Directory containing raw frame grabs
    $cropped = '../cropped';	    # Directory where cropped PNG files will be placed
    $sicle = '../preview';    	    # Directory for preview GIF animation and frame files
    $preview = "transit.gif";	    # Name of preview GIF animation
    $jpegdir = "../jpeg";   	    # JPEG frame directory
    $titledir = "../title";   	    # Title frame directory
    $ppmdir = "../ppm";   	    # PPM frame directory
    
    $cropsize = 160;	    	    # Size to which frames are cropped
    $xstretch = 1.09375;    	    # X stretch factor for square pixels
    $framerate = 10;	    	    # Time per frame, hundredths of a second
    $audio_duration = 139;   	    # Sound track duration in seconds (needn't be integral)
    
    #	Utilities invoked by this program may be downloaded from the
    #	following locations:
    
    #	NETPBM Image Processing Toolkit
    #	    http://netpbm.sourceforge.net/
    
    #	Gifsicle GIF Animation Assembler
    #	    http://www.lcdf.org/gifsicle/
    
    #	Independent JPEG Group JPEG Encoder/Decoder
    #	    http://www.ijg.org/
    
    #	MPLAYER/MENCODER Movie Player/Encoder for Linux
    #	    http://www.mplayerhq.hu/
    
    #	Crop Job

    if ($crop_job) {
    
	#   Chew through the images in the $grab directory
	#   and generate corresponding cropped images in $cropped.

	#   Note that we wrap a black margin around the grabbed images
	#   before cropping them.  This handles the case where the
	#   region we want to crop is too close to the edge for the
	#   desired border size.

	#   We save the cropped images in PNG as a compressed, non-lossy
	#   format for further processing.
    
	opendir(CD, $grab);
	@tiffs = grep(/\.png$/, readdir(CD));
	closedir(CD);
	@tiffs = sort(@tiffs);

	$nfiles = 0;

	foreach $f (@tiffs) { 
	    $input = "$grab/$f";
	    $base = $f;
	    $base =~ s/\.png//;
	    $output = $base;
	    $output = "$cropped/$output.png";

	    print("$input -> $output\n");

	    $centre = `pngtopnm $input | ppmnorm | pnmmargin -black $cropsize | ./cropcircle`;
	    $centre =~ m/\s*(\d+)\s+(\d+)\s*/;
	    ($ctrx, $ctry) = ($1, $2);

	    $left = $ctrx - int($cropsize / 2);
	    $top = $ctry - int($cropsize / 2);

	    $c = "pngtopnm $input | " . 
		 "pnmmargin -black $cropsize | " .
		 "pnmcut -left $left -top $top -width $cropsize -height $cropsize | " .
		 "pnmtopng -compress 9 >$output\n";
	    &command($c);

	    $nfiles++;
#if ($nfiles >= 10) {
#    last;
#}
	}
    }
    
    #	Assemble the cropped images into an animated GIF for previewing
    
    if ($preview_job) {
    
	my $gs = "gifsicle --colors 256 --delay $framerate --loopcount=forever";

	opendir(CD, $cropped);
	@tiffs = grep(/\.png$/, readdir(CD));
	closedir(CD);
	@tiffs = sort(@tiffs);

    	$vfn = 0;
	foreach $f (@tiffs) { 
	    $vfn++;
	    $input = "$cropped/$f";
	    $base = $f;
	    $base =~ s/\.png//;
	    $output = $base;
	    $output = "$sicle/$output.gif";

	    print("$input -> $output\n");
	    
	    &process;

	    $c = "pngtopnm $input $process | " .
	    	"ppmquant 256 >/tmp/$$.ppm\n";
	    &command($c);
	    $imsize = `pnmfile /tmp/$$.ppm\n`;
	    $imsize =~ m/(\d+) by (\d+) /;
	    ($imx, $imy) = ($1, $2);
#print("Original image size: $imx by $imy\n");
    	    
	    $left = int(($imx - $cropsize) / 2);
	    $top = int(($imy - $cropsize) / 2);
	    $c = "pnmcut -left $left -top $top -width $cropsize -height $cropsize /tmp/$$.ppm | " .
		 #   The next line labels the images in the preview with their
		 #   source file name.  If you don't like that, comment out
		 #   the line.
		 "ppmlabel -x 8 -y 150 -size 9 -text $base | " .
	    	 "ppmtogif >$output\n";
	    &command($c);
	    &command("rm /tmp/$$.ppm\n");

	    $gs .= " $output";
	    $nfiles++;
#if ($nfiles >= 10) {
#    last;
#}
	}

	$gs .= " >$sicle/$preview\n";
	&command($gs);
    }

    #	Prepare JPEG frames from cropped images
        
    if ($jpeg_job) {
    
	my $gs = "Whatever";

	opendir(CD, $cropped);
	@tiffs = grep(/\.png$/, readdir(CD));
	closedir(CD);
	@tiffs = sort(@tiffs);

    	$vfn = 0;
	foreach $f (@tiffs) { 
	    $vfn++;
	    $input = "$cropped/$f";
	    $base = $f;
	    $base =~ s/\.png//;
	    $output = $base;
	    $output = "$jpegdir/$output.jpg";

	    print("$input -> $output\n");
	    
	    &process;
	    
	    $c = "pngtopnm $input $process | " .
	    	"ppmquant 256 >/tmp/$$.ppm\n";
	    &command($c);
	    $imsize = `pnmfile /tmp/$$.ppm\n`;
	    $imsize =~ m/(\d+) by (\d+) /;
	    ($imx, $imy) = ($1, $2);
#print("Original image size: $imx by $imy\n");
    	    
	    $left = int(($imx - $cropsize) / 2);
	    $top = int(($imy - $cropsize) / 2);
	    $c = "pnmcut -left $left -top $top -width $cropsize -height $cropsize /tmp/$$.ppm | " .
	    	 "cjpeg >$output\n";
	    &command($c);
	    &command("rm /tmp/$$.ppm\n");

	    $gs .= " $output";
	    $nfiles++;
#if ($nfiles >= 10) {
#    last;
#}
	}
    }
    
    #	Encode JPEG frames and MP3 sound track as AVI movie
     
     if ($avi_job) {
	my $menc = "-audiofile ../sound_track/sousaTOV_titled.mp3 -oac copy " .
#	    	   "-noskip " .
#		   "-mf fps=$framerate -ovc lavc -lavcopts vcodec=wmv1:vbitrate=250 " .
#		   "-mf fps=$framerate -ovc lavc -lavcopts vcodec=wmv1 " .
		   "-mf fps=$framerate -ovc lavc -lavcopts vcodec=msmpeg4v2 " .
		   "-info 'name=\"Transit of Venus, 2004-06-08\":artist=John Walker, www.fourmilab.ch:copyright=\"This movie is in the public domain\"' " .
		   "-o ../movies/transit.avi";


	opendir(CD, $jpegdir);
	@tiffs = grep(/\.jpg$/, readdir(CD));
	closedir(CD);
	@tiffs = sort(@tiffs);
	
if (0) {
	command("rm ../jpeglinks/*.jpg\n");
	
	#   Link all title frames to start of movie
	
	opendir(CD, $titledir);
	@tframes = grep(/\.jpg$/, readdir(CD));
	closedir(CD);
	@tframes = sort(@tframes);
	$i = 0;	
	foreach $f (@tframes) {
	    $c = sprintf("ln -s '$titledir/$f' ../jpeglinks/a%04d.jpg\n", $i);
	    &command($c);
	    $i++;
	}
	
	#   Now link captured frames to the movie directory.  We skip
	#   or duplicate frames as required to adjust the length of the
	#   movie to that of the sound track.

    	$vfn = 0;
	$ffiles = '';
	$nframes = $audio_duration * $framerate;
	for ($i = 0; $i <= $nframes; $i++) { 
	    $vfn++;
	    $n = int((($#tiffs + 1) / $nframes) * $i);
	    $input = "$jpegdir/$tiffs[$n]";

	    $ffiles .= " $input";
	    $c = sprintf("ln -s $input ../jpeglinks/f%04d.jpg\n", $i);
	    &command($c);
	    $nfiles++;
#if ($nfiles >= 10) {
#    last;
#}
	}
}
	&command("mencoder \"mf://../jpeglinks/*.jpg\" $menc\n");
     }

    #	Prepare PPM frames from cropped images
        
    if ($ppm_job) {
    
	my $gs = "Whatever";

	opendir(CD, $cropped);
	@tiffs = grep(/\.png$/, readdir(CD));
	closedir(CD);
	@tiffs = sort(@tiffs);

	foreach $f (@tiffs) { 
	    $input = "$cropped/$f";
	    $base = $f;
	    $base =~ s/\.png//;
	    $output = $base;
	    $output = "$ppmdir/$output.ppm";

	    print("$input -> $output\n");

	    $c = "pngtopnm $input | pnmmargin -black 5 >$output\n";
	    &command($c);

	    $gs .= " $output";
	}
    }

    #	Ad-hoc processing for groups of cropped images
    
    sub process {
    	my ($xscale, $yscale) = ($xstretch, 1);
	#   Ad-hoc correction for different zoom factors in segments
	#   of the movie.
	my $size = 104;
	my $asize;
	my $sc = "";
	if ($vfn < 125) {
	    $asize = 99;
    	} elsif (($vfn >= 125) && ($vfn <= 503)) {
	    $asize = 103;
   	} elsif (($vfn >= 504) && ($vfn <= 626)) {
	    $asize = 96;
   	} elsif (($vfn >= 627) && ($vfn <= 1315)) {
	    $asize = 99;
	} else {
	    $asize = 104;
	}
	
	if ($vfn <= 340) {
	    $sc = "| ppmbrighten -v 12 ";
	}
	
	$xscale *= $size / $asize;
	$yscale *= $size / $asize;
    	$process = "$sc | pnmscale -xscale $xscale -yscale $yscale";
#	$process .= " | ppmnorm  -bpercent 10 -wpercent 0";
    }
    
    #	Print a command and then do it
    
    sub command {
    	my ($c) = @_;
	
	print($c);
	system($c);
    }
